using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using Clio.Utilities;
using Clio.XmlEngine;
using ff14bot.Behavior;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.Settings;
using TreeSharp;
using Action = TreeSharp.Action;

using System.Threading;
using System.Runtime.InteropServices;

namespace ff14bot.NeoProfiles
{
    [XmlElement("FishBot")]
    public class FishBotTag : ProfileBehavior
    {
        [XmlAttribute("While")]
        public string whileCondition { get; set; }
        
        [XmlAttribute("Profile")]
        public string profile { get; set; }
        
        private bool _done = false;

        public override bool IsDone { get { return _done; } }
        
        public static bool isRunning = false;
        public static Func<bool> Conditional;

        protected override Composite CreateBehavior() {
            return new PrioritySelector(
                new Decorator(ret => true, new Action(r => {
                    string profilePath = ff14bot.Helpers.Utils.AssemblyDirectory + @"\Plugins\IxaliSupport\" + profile;
                    isRunning = true;
                    Conditional = ScriptManager.GetCondition(whileCondition);
                    loadFishingBot(profilePath);
                }))
            );
        }
        
        public static void loadFishingBot(string file) {
            ThreadPool.QueueUserWorkItem(o => {
                try {
                    Navigator.Stop();
                    TreeRoot.Stop();
                    Thread.Sleep(1500);
                    BotManager.SetCurrent(BotManager.Bots.FirstOrDefault(u => u.Name.Contains("Fishing")));
                    Logging.Write("[IxaliSupport] Changed BotBase to Fishing");
                    ProfileManager.LoadNew(file, true);
                    Logging.Write("[IxaliSupport] Loaded Waypoint profile " + file);
                    Thread.Sleep(1500);
                    TreeRoot.Start();
                }
                catch (Exception treerootexception) {
                    Logging.Write("[IxaliSupport] Error: {0}", treerootexception);
                }
            });
        }
        
        protected override void OnDone()
        {
            _done = false;
        }

    }
}